#version 330

layout(location = 0) in vec3 position;
layout(location = 1) in vec2 vertexUV;
layout(location = 2) in vec3 vertexNormal_modelspace;

out vec2 UV;
out vec3 Normals;
out vec3 Position_worldspace;
out vec3 Position_fragment;
out vec4 LightSpacePosition_fragment;

uniform mat4 matModel;
uniform mat4 matWorld;
uniform mat4 matView;
uniform mat4 matProjection;
uniform mat4 lightMat;

void main() {
	gl_Position = matProjection * matView * matWorld * matModel * vec4(position, 1);
	Position_worldspace = vec3(gl_Position.x,gl_Position.y, gl_Position.z) ;
	UV = vertexUV;
	Normals = mat3(transpose(inverse(matWorld * matModel))) * vertexNormal_modelspace;
	Position_fragment = vec3(matWorld * matModel * vec4(position, 1));
	LightSpacePosition_fragment = lightMat * vec4(Position_fragment, 1.0);
}