#version 330 core
layout(location = 0) in vec4 vertexPosition_modelspace;
layout(location = 1) in vec2 vertexUV;
layout(location = 2) in vec3 vertexNormal_modelspace;

out vec2 UV;
out vec3 Position_worldspace;
out vec3 Normal_cameraspace;
out vec3 EyeDirection_cameraspace;
out vec3 LightDirection_cameraspace;

out int bSpotlight1;
out vec4 vecSpotlight1Pos;
out vec4 vecSpotlight1Normal;

uniform mat4 matModel;
uniform mat4 matWorld;
uniform mat4 matView;
uniform mat4 matProjection;
uniform vec3 LightPosition;

uniform int bSpotlight1_uf;
uniform vec3 vecSpotlight1Pos_uf;
uniform vec3 vecSpotlight1Normal_uf;
uniform mat4 matSpotlight1Model_uf;
uniform mat4 matSpotlight1World_uf;

void main(){

//Spotlight
bSpotlight1 = bSpotlight1_uf;
//<<<<<<< HEAD
//vecSpotlight1Pos = vec3(matProjection * matView * matSpotlight1World_uf * matSpotlight1Model_uf * vec4(vecSpotlight1Pos_uf,1.0));
//vecSpotlight1Normal = vec3(matProjection * matView * matSpotlight1World_uf * matSpotlight1Model_uf * vec4(vecSpotlight1Normal_uf,1.0));
//=======
//vecSpotlight1Pos = matProjection * matView * matSpotlight1World_uf * matSpotlight1Model_uf * vec4(vecSpotlight1Pos_uf,1.0);
//vecSpotlight1Normal = matProjection * matView * matSpotlight1World_uf * matSpotlight1Model_uf * vec4(vecSpotlight1Normal_uf,1.0);
vecSpotlight1Pos = matSpotlight1World_uf * matSpotlight1Model_uf * vec4(vecSpotlight1Pos_uf,1.0);
vecSpotlight1Normal = matSpotlight1World_uf * matSpotlight1Model_uf * vec4(vecSpotlight1Normal_uf,1.0);
//>>>>>>> origin/master
//Spotlight

gl_Position = matProjection * matView * matWorld * matModel * vec4(vertexPosition_modelspace.xyz,1);

UV = vertexUV;

Position_worldspace = vec3(matWorld * matModel * vec4(vertexPosition_modelspace.xyz, 1));

Normal_cameraspace = vec3(matView * matWorld * matModel * vec4(vertexNormal_modelspace.xyz,0));


vec3 Position_cameraspace = vec3( matView * matWorld * matModel * vec4(vertexPosition_modelspace.xyz, 1));
//im cameraspace ist die Kamera an der Stelle (0, 0, 0)
EyeDirection_cameraspace = vec3(0, 0, 0) - Position_cameraspace;

vec3 LightPosition_cameraspace = vec3( matView * vec4(LightPosition.xyz, 1));
LightDirection_cameraspace = LightPosition_cameraspace + EyeDirection_cameraspace;

}
