#version 330

layout(location = 0) in vec3 position;
layout(location = 1) in vec2 vertexUV;
layout(location = 2) in vec3 vertexNormal_modelspace;
layout(location = 3) in vec3 normalTangent;
layout(location = 4) in vec3 normalBiTangent;

out vec2 UV;
out vec3 Normals;
out vec3 Position_fragment;
out vec3 Position_worldspace;
out vec3 _positionCamera;

//NormalMapping
out vec3 vertexNormal_cameraspace;
out vec3 vertexTangent_cameraspace;
out vec3 vertexBitangent_cameraspace;
out mat3 TBN_Out;
//out vec3 LightDirection_tangentspace;
out vec3 EyeDirection_tangentspace;

uniform mat4 matModel;
uniform mat4 matWorld;
uniform mat4 matView;
uniform mat4 matProjection;

uniform vec3 positionCamera;
uniform vec3 positionMinion;

uniform mat4 lightMat;

void main() {

	gl_Position = matProjection * matView * matWorld * matModel * vec4(position, 1);
	
	//Normals = mat3(transpose(inverse(matWorld * matModel))) * vertexNormal_modelspace;
	//Position_fragment = vec3(matWorld * matModel * vec4(position, 1));
	//Position_fragment = vec3(transpose(inverse(matWorld * matModel))) * position;
	Normals = vec3(matWorld * matModel * vec4(vertexNormal_modelspace, 1));
	Position_fragment = vec3(matWorld * matModel * vec4(position, 1));

	_positionCamera  = positionCamera;

	Position_worldspace = vec3(gl_Position.x,gl_Position.y, gl_Position.z) ;
	UV = vertexUV;

	//normalMapping
	mat3 vwm = transpose(inverse(mat3(matView * matWorld * matModel)));
	vertexNormal_cameraspace = normalize(vwm * vertexNormal_modelspace);
    vertexTangent_cameraspace = normalize(vwm * normalTangent);
    vertexBitangent_cameraspace = normalize(vwm * normalBiTangent);

	mat3 TBN = transpose(mat3(vertexTangent_cameraspace,vertexBitangent_cameraspace,vertexNormal_cameraspace));
	//LightDirection_tangentspace = normalize(TBN * vec3(5,5,5));//vorerst spter nchstbestes spotlight
	TBN_Out = TBN;
	EyeDirection_tangentspace =  normalize(TBN * positionCamera);
}